class Checker
  def initialize(mailbox, interval)
    @interval = interval
    @mailbox  = mailbox
    @unread   = nil
  end

  def run
    rotate do
      @mailbox.prepare
      present(@mailbox.getnum)
    end
  end

  private

  def present(number)
    puts "You have got #{number} unread messages." if @unread != number
    @unread = number
  end

  def rotate
    loop do
      yield
      sleep @interval
    end
  end
end
