# container for mail methods
class Mailbox
  def initialize(info)
    @info = info
    @box  = nil
  end

  def prepare
    host = @info.host
    port = @info.port
    ssl  = @info.ssl
    user = [@info.login, @info.password]
    if @info.pop
      @box = Net::POP3.new(host, port)
      @box.use_ssl if ssl
      @box.start(*user)
    else
      @box = Net::IMAP.new(host, port, ssl: ssl)
      @box.login(*user)
    end
  end

  def getnum
    if @info.pop
      num_pop
    else
      num_imap
    end
  end

  private

  def num_pop
    @box.mails.length
  end

  def num_imap
    @box.examine('INBOX')
    number = @box.search('UNSEEN').length
    imap_end
    number
  end

  def imap_end
    @box.logout
    @box.disconnect
  end
end
